#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>


typedef struct _ImMain
{
  char ImFileName[256];
  char OutImFileName[256];
  unsigned char * HeaderPtr;
  unsigned char * InPixelPtr;
  unsigned char * OutPixelPtr;
  short * ShortPixelPtrWide;
  short * Gxy;
  char SobelX[3][3];
  char SobelY[3][3];
  int HorImSize;
  int VertImSize;
} ImMain;

int InitDataStruct (ImMain * ImStruct);
int ParseInputs (int argc, char *argv[], ImMain * ImStruct);
void Usage (void);
int WriteImage(ImMain *ImStruct);
int ImageFilter(ImMain *ImStruct);
int FreeDataStruct(ImMain *ImStruct);
